<template>
  <div class="main-box">
    <LjFoldLayout ref="LjFoldLayoutRef" v-bind="layoutSetting" :dwname="dwname">
      <template #left>
        <TreeFilter
          ref="LjTreeRef"
          id="mtrltypeid"
          label="mtrltype"
          :searchable="false"
          :expand-on-click-node="true"
          :request-api="gMtrltypeList"
          @change="changeTreeFilter"
        />
      </template>
      <div class="main-box flx-col">
        <LjVxeTable
          ref="VxeTableRef"
          row-key="mtrlid"
          :columns="columns"
          :request-api="getData"
          :data-callback="dataCallback"
          :dwname="dwname"
          :table-props="tableProps"
          :table-events="tableEvents"
          :init-param="initParams"
          :auto-load-layout="false"
          pagination
        >
          <!-- 表格 header 按钮 -->
          <template #tableHeader>
            <el-button-group>
              <el-button @click="handleOpenNewTable">{{ $t("common.add") }}</el-button>
              <el-button @click="fDelete">{{ $t("common.delText") }}</el-button>
              <el-button @click="fBan">{{ $t("common.disable") }}</el-button>
            </el-button-group>
          </template>
        </LjVxeTable>
      </div>
    </LjFoldLayout>
  </div>

  <LjDialog
    ref="LjDrawerRef"
    class="is-selector"
    v-bind="{
      ...drawerDefineProp
    }"
    :style="{ padding: 0 }"
  >
    <template #header>
      <div class="flx-1">
        <span class="text-h5-b">物料: {{ mtrlname }}</span>
      </div>
    </template>
    <div class="flx-1 h-full">
      <LjHeaderMenu :data="mainData" :action="orderStatus ? orderEditAction : orderDefaultAction" />
      <Detail class="flx-1" :data="mainData" :status="orderStatus" :enum="enumMap" />
    </div>
  </LjDialog>
</template>

<script setup lang="ts" name="baseinfo_mtrldeflist">
import { ref, onMounted, provide } from "vue";
import { getMtrlDefList } from "@/api/modules/basicinfo";
import { useHooks as useHooks_mtrltype } from "@/views/baseinfo/mtrltype/hooks/index";
import Detail from "./detail.vue";
import { useHooks } from "./hooks/index";
import LjDialog from "@/components/LjDialog/index.vue";
import LjHeaderMenu from "@/components/LjHeaderMenu/index.vue";
import { useI18n } from "vue-i18n";
import { useAuthButtons } from "@/hooks/useAuthButtons";
import { cloneDeep } from "lodash-es";
import { traverseNode } from "@/utils/index";

const dwname = "web_mtrldeflist";
const mainData = ref({});
const mtrltype = ref({});
const initParams = ref({ mtrltypeids: undefined as Number[] });
const tableProps = {
  height: "auto",
  editConfig: { trigger: "click", mode: "cell" }
  // rowClassName: rowClsNameFunc
  // exportConfig: {
  //   filename: t("menu.saletaskmx") + formatToDate(new Date(), "YYYY-MM-DD HH:mm:ss")
  // }
};

const layoutSetting = {
  dwname: dwname,
  right: {
    hidden: true
  }
};

const { t } = useI18n();
const { VxeTableRef, LjDetailRef, VxeTableMxRef, columns, fDelete, fSave, fBan } = useHooks(t);
const { gMtrltypeList } = useHooks_mtrltype(t);
const { CheckPower, CheckOption, buttonNew, buttonDefault } = useAuthButtons(t);

const orderStatus = ref("");
const mtrlname = ref("");
const enumMap = ref(new Map());

const orderDefaultAction = [
  buttonDefault({
    label: t("common.cancelText"),
    icon: "iconchevron-left"
  }),
  buttonNew({
    label: t("common.saveText"),
    icon: "iconsave-01",
    clickFunc: item => {
      const save_data = orderStatus.value == "new" ? LjDetailRef.value?.infoParam : LjDetailRef.value?._mainData;

      save_data.mxlist = VxeTableMxRef.value?.tableData;
      fSave({ mtrl: save_data }).then(() => {
        LjDrawerRef.value.hide();
      });
    }
  })
];
const orderEditAction = [
  buttonNew({
    label: t("common.saveText"),
    icon: "iconsave-01",
    clickFunc: item => {
      const save_data = orderStatus.value == "new" ? LjDetailRef.value?.infoParam : LjDetailRef.value?._mainData;

      save_data.mxlist = VxeTableMxRef.value?.tableData;
      fSave({ mtrl: save_data }).then(() => {
        LjDrawerRef.value.hide();
      });
    }
  })
];

const changeTreeFilter = (val: any) => {
  console.log("val :>> ", val);
  let mtrltypeids = [] as Number[];
  traverseNode(val, (node: any) => node?.mtrltypeid && mtrltypeids.push(parseInt(node.mtrltypeid)));
  initParams.value.mtrltypeids = mtrltypeids.length > 0 ? mtrltypeids : undefined;
};

/*
 * @description 抽屉默认属性
 */
const drawerDefineProp = {
  draggable: true,
  overflow: true,
  width: "40%"
  // modalClass: "lj-file-dialog"
};

const getData = (params: any) => {
  return getMtrlDefList(params);
};

const dataCallback = (data: any) => {
  if (data.tableinfo?.columns) {
    data.tableinfo?.columns.map((item: any) => {
      if (item?.enum) {
        enumMap.value.set(item.field, item.enum);
      }
    });
  }
  return {
    list: data.datatable,
    tableinfo: data.tableinfo,
    total: data.totalcnt,
    pageNum: data.pageindex,
    pageSize: data.pagesize
  };
};

const LjDrawerRef = ref();
const handleDBlClickTable = ({ row, rowIndex, $rowIndex, column, columnIndex, $columnIndex, $event }: any) => {
  // 弹窗
  mainData.value = cloneDeep(row);
  mtrlname.value = row.name;
  orderStatus.value = "edit";
  LjDrawerRef.value.show();
};

const handleOpenNewTable = () => {
  mainData.value = {
    mtrlid: 0
  };
  mtrlname.value = "";
  orderStatus.value = "new";
  LjDrawerRef.value.show();
};

// 返回绑定的事件
const tableEvents = {
  "cell-dblclick": handleDBlClickTable
  // "cell-click": handleClickTable
};
</script>
